<template>
  <section class="pb-32">
    <Header />
    <Method />
    <ListMethod
      :remove="remove"
      :cart="cart"
      :decrement="decrement"
      :increment="increment"
    />
    <TotalHarga :cart="cart" />
    <hr class="h-2 bg-1100 border-0" />
    <Catatan :catatan="catatan" />
    <TotalPembayaran :cart="cart" />
  </section>
</template>

<script>
import Header from "./content/Header.vue";
import ListMethod from "./content/ListMethod.vue";
import Method from "./content/Method.vue";
import TotalHarga from "./content/TotalHarga.vue";
import Catatan from "./content/Catatan.vue";
import TotalPembayaran from "./content/TotalPembayaran.vue";

let cart = window.localStorage.getItem("cart");

export default {
  name: "ComponentCart",
  components: {
    ListMethod,
    Method,
    TotalHarga,
    Catatan,
    TotalPembayaran,
    Header,
  },

  //state
  data() {
    return {
      //cart
      cart: cart ? JSON.parse(cart) : [],
      total: "",
    };
  },

  //methods
  methods: {
    decrement(item, index) {
      const check = item.products
        .map((d) => {
          return d.id;
        })
        .values()
        .next().value;

      let found;
      found = this.cart
        .map((d) => {
          return d.products.values().next().value;
        })
        .find((product) => product.id == check);

      //checking quantity
      if (found.quantity > 1) {
        found.quantity--;
        found.total = found.price * found.quantity;
      } else if (found.quantity == 1) {
        this.cart.splice(index, 1);
      }
      localStorage.setItem("cart", JSON.stringify(this.cart));
    },
    increment(item) {
      const check = item.products
        .map((d) => {
          return d.id;
        })
        .values()
        .next().value;

      let found;
      found = this.cart
        .map((d) => {
          return d.products.values().next().value;
        })
        .find((product) => product.id == check);

      if (found) {
        found.quantity++;
        found.total = found.price * found.quantity;
      }
      localStorage.setItem("cart", JSON.stringify(this.cart));
    },
    remove(item) {
      this.cart.splice(item, 1);
      localStorage.setItem("cart", JSON.stringify(this.cart));
    },
  },
};
</script>
